//------------------------------------------------------------------------------
//title
//	[^vO
//ver
//	1.0
//designer
//	igeta kenichiro
//------------------------------------------------------------------------------

#include <machine.h>
#include <_h_c_lib.h>
#include "iodefine.h"

#define MPU_CLK			20000000UL					//}CRg[Hz]
#define MPU_TIME		(1000000000L/MPU_CLK)		//}CR쎞[ns]
#define TIME_BASE		1000000L					//[ns]
#define ENCODER_PULSE	1000						//GR[_pX
#define CONVERT_BASE	(MPU_CLK/ENCODER_PULSE*60)	//x=CONVERT_BASE/pX
#define LOG_SIZE		160							//f[^
#define SPEED_LOOP		1							//x[ms]

//------------------------------------------------------------------------------

void MotorOut(unsigned int out, int dir);
void SpeedLoop(void);
void initialize(void);
void Sleep(unsigned long time);
void main(void);

//------------------------------------------------------------------------------

volatile unsigned long gSystemTime;

volatile unsigned int gWidthA;		//pX(A)
volatile int gSetSpeed;				//ݒ葬x
int gProportionalGain = 250;		//QC

int gSpeedLog[LOG_SIZE];			//葬xobt@
int gSetSpeedLog[LOG_SIZE];			//ݒ葬xobt@
int gLogCount = LOG_SIZE;

int gSppedTable[] = {				//xe[u[r/min]
 0,  300,  600,  900,  1200,  1500,  1800,  2100,
 0, -300, -600, -900, -1200, -1500, -1800, -2100
};

//------------------------------------------------------------------------------
//	^C}[v
//------------------------------------------------------------------------------

__interrupt(vect=21)
void INT_TimerW(void)
{
	static int oldCapTime;
	static int flag;

	//pX
	if(TW.TSRW.BIT.IMFA){					//pXoH
		IO.PDR5.BIT.B2 = 0;					//LED2on
		TW.TSRW.BIT.IMFA = 0;
		if(flag == 0){
			gWidthA = TW.GRA - oldCapTime;	//pXvZ
		}
		oldCapTime = TW.GRA;
		TW.GRC = TW.GRA+0x8000;				//pXI[o[t[ݒ
		flag = 0;

	}
	//pX\͈͂𒴂Ăꍇ̏
	if(TW.TSRW.BIT.IMFC){					//pXI[o[t[H
		IO.PDR5.BIT.B2 = 1;					//LED2off
		TW.TSRW.BIT.IMFC = 0;
		TW.GRC = TW.GRC+0x8000;
		gWidthA = 0xffff;					//pXőɐݒ
		flag = 1;							//pXI[o[t[tOZbg

	}
	//ݏ
	if(TW.TSRW.BIT.IMFD){					//ݔH
		TW.TSRW.BIT.IMFD = 0;
		TW.GRD = TW.GRD+TIME_BASE/MPU_TIME;	//TIME_BASEԎŊ
		gSystemTime += TIME_BASE/1000000;
		if(gSystemTime%SPEED_LOOP==0){		//xH
			SpeedLoop();
		}
	}
}

//------------------------------------------------------------------------------
//	[^hCoo
//------------------------------------------------------------------------------

void MotorOut(unsigned int out, int dir)
{
	TV.TCORB = out >> 8;					//ovlݒ

	if(IO.PDRB.BIT.B2 == 1 && out == 0){//V[gu[L[hH
		IO.PDR5.BIT.B1 = 0;					//LED1on
		IO.PDR7.BIT.B4 = 0;
		IO.PDR7.BIT.B5 = 0;

	}else if(dir >= 0){						//]H
		IO.PDR5.BIT.B1 = 1;					//LED1off
		IO.PDR7.BIT.B4 = 1;
		IO.PDR7.BIT.B5 = 0;

	}else{									//]H
		IO.PDR5.BIT.B1 = 1;					//LED1off
		IO.PDR7.BIT.B4 = 0;
		IO.PDR7.BIT.B5 = 1;
	}
}

//------------------------------------------------------------------------------
//	x
//------------------------------------------------------------------------------

void SpeedLoop(void)
{
	static int count;
	static int speed;
	int setSpeed;
	int proportionalGain;
	int difference;
	long proportional;

	setSpeed = gSetSpeed;
	proportionalGain = gProportionalGain;
	if(IO.PDRB.BIT.B3 == 1){
		proportionalGain = proportionalGain*2;	//QCQ{
	}

	//pXx(xtB[hobNM)ϊ
	if(gWidthA < 0x7fff){
		speed = CONVERT_BASE/gWidthA;	//pXȂƂxvZ

	}else{
		speed = 0;						//pXs\ȂƂx0
	}

	//xf[^ۑ(sv)
	if(gLogCount < LOG_SIZE){
		if(count%5==0){
			gSpeedLog[gLogCount] = speed;
			gSetSpeedLog[gLogCount] = setSpeed;
			gLogCount++;
		}
		count++;
	}

	//΍vZ
	//΍=xw-xtB[hobNM
	if(setSpeed >= 0){
		difference = setSpeed-speed;	//]̂Ƃ
	}else{
		difference = -setSpeed-speed;	//t]̂Ƃ
	}

	//QCZ
	proportional = difference * proportionalGain;
	if(proportional > 0xffff){			//̒llȏH
		proportional = 0xffff;
	}else if(proportional < 0){			//̒llȉH
		proportional = 0;
	}

	//[^[^hCoo
	MotorOut(proportional, setSpeed);
}

//------------------------------------------------------------------------------
//	
//------------------------------------------------------------------------------

void initialize(void)
{
	IO.PDR1.BYTE = 0xf8;
	IO.PCR1      = 0xef;

	IO.PDR2.BYTE = 0xff;
	IO.PCR2      = 0xfd;

	IO.PDR5.BYTE = 0xff;
	IO.PCR5      = 0xff;

	IO.PDR7.BYTE = 0x8f;
	IO.PCR7      = 0xff;

	IO.PDR8.BYTE = 0xff;
	IO.PCR8      = 0xf9;

	//^C}[uݒ
	//PWMg=MPU_CLK/4/256
	TV.TCRV0.BYTE = 0x09;
	TV.TCRV1.BYTE = 0x00;
	TV.TCSRV.BYTE = 0x06;
	TV.TCORA      = 255;
	TV.TCORB      = 0;

	//^C}[vݒ
	TW.TMRW.BYTE  = 0x80;
	TW.TCRW.BYTE  = 0x00;
	TW.TIERW.BYTE = 0x0d;
	TW.TIOR0.BYTE = 0x44;
	TW.TIOR1.BYTE = 0x00;
	TW.GRC = 0x8000;
	TW.GRD = TIME_BASE/MPU_TIME;

	set_imask_ccr(0);				//݋

	//VA|[gݒ(sv)
//	SCI3.SCR3.BYTE = 0x00;
//	SCI3.SMR.BYTE = 0x00;
//	SCI3.BRR = 15;
//	IO.PMR1.BIT.TXD = 1;
//	Sleep(10);
//	SCI3.SCR3.BIT.TE = 1;
//	SCI3.SCR3.BIT.RE = 1;
//	SCI3.SCR3.BIT.RIE = 1;	//M݋
}

//------------------------------------------------------------------------------
//	ԑ҂[ms]
//------------------------------------------------------------------------------

void Sleep(unsigned long time)
{
	unsigned long oldTime = gSystemTime;

	while(gSystemTime-oldTime <= time){
		sleep();	//邱Ƃ̂Ń}CR~
	}
}

//------------------------------------------------------------------------------
//	C
//------------------------------------------------------------------------------

void main(void)
{
	int sw;

	initialize();

	while(1){
		while(IO.PDR1.BIT.B4 == 1){	//SW܂ő҂
			Sleep(10);
		}
		IO.PDR5.BIT.B0 = 0;			//LED0on
		sw = IO.PDRB.BYTE >> 4;
		gLogCount = 0;				//sv
		Sleep(10);
		gSetSpeed = gSppedTable[sw];//DIPSWe[uϊőxɂ

		while(IO.PDR1.BIT.B4 == 0){	//SW܂ő҂
			Sleep(10);
		}
		IO.PDR5.BIT.B0 = 1;			//LED0off
	}
}

//------------------------------------------------------------------------------
